#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ocl.h"

#include "app.h"

struct A** a_instances = NULL;
int a_size = 0;

struct B** b_instances = NULL;
int b_size = 0;

struct A** newAList(void)
{ return (struct A**) calloc(ALLOCATIONSIZE, sizeof(struct A*)); }

struct B** newBList(void)
{ return (struct B**) calloc(ALLOCATIONSIZE, sizeof(struct B*)); }

int getA_x(struct A* self) { return self->x; }

int getB_y(struct B* self) { return self->y; }

int getB_z(struct B* self) { return self->z; }

void setA_x(struct A* self, int _value) { self->x = _value; }

void setB_y(struct B* self, int _value) { self->y = _value; }

void setB_z(struct B* self, int _value) { self->z = _value; }

int* getAllA_x(struct A* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getA_x(_col[i]); }
  return result;
}

int* getAllB_y(struct B* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getB_y(_col[i]); }
  return result;
}

int* getAllB_z(struct B* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getB_z(_col[i]); }
  return result;
}

struct A** appendA(struct A* col[], struct A* ex)
   { struct A** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct A**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct A*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct B** appendB(struct B* col[], struct B* ex)
   { struct B** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct B**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct B*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

void addA(void* obj)
{ a_instances = appendA(a_instances, (struct A*) obj);
  a_size++;
}

void addB(void* obj)
{ b_instances = appendB(b_instances, (struct B*) obj);
  b_size++;
}

struct A* createA(void)
{ struct A* result = (struct A*) malloc(sizeof(struct A));
  result->x = 0;
  addA(result);
  return result;
}

struct B* createB(void)
{ struct B* result = (struct B*) malloc(sizeof(struct B));
  result->y = 0;
  result->z = 0;
  addB(result);
  return result;
}

struct A** insertA(struct A* col[], struct A* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendA(col,self);
  }

struct B** insertB(struct B* col[], struct B* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendB(col,self);
  }

 unsigned char existsB(struct B* col[], unsigned char (*test)(struct B*))
 { int n = length((void**) col);
   unsigned char result = FALSE;
   int i = 0;
   for ( ; i < n; i++)
   { struct B* ex = col[i];
     if (ex == NULL) { return result; }
     if ((*test)(ex))
     { return TRUE; }
   }
   return result;
 }

  struct A** subrangeA(struct A** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct A** result = (struct A**) calloc(j - i + 2, sizeof(struct A*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct B** subrangeB(struct B** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct B** result = (struct B**) calloc(j - i + 2, sizeof(struct B*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct A** reverseA(struct A** col)
  { int n = length((void**) col);
    struct A** result = (struct A**) calloc(n+1, sizeof(struct A*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

  struct B** reverseB(struct B** col)
  { int n = length((void**) col);
    struct B** result = (struct B**) calloc(n+1, sizeof(struct B*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

struct A** removeA(struct A* col[], struct A* ex)
{ int len = length((void**) col);
  struct A** result = (struct A**) calloc(len+1, sizeof(struct A*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct A* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct B** removeB(struct B* col[], struct B* ex)
{ int len = length((void**) col);
  struct B** result = (struct B**) calloc(len+1, sizeof(struct B*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct B* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct A** removeAllA(struct A* _col1[], struct A* _col2[])
{ int n = length((void**) _col1);
  struct A** result = (struct A**) calloc(n+1, sizeof(struct A*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct A* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct B** removeAllB(struct B* _col1[], struct B* _col2[])
{ int n = length((void**) _col1);
  struct B** result = (struct B**) calloc(n+1, sizeof(struct B*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct B* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct A** frontA(struct A* _col[])
{ int n = length((void**) _col);
  return subrangeA(_col, 1, n-1); }

struct B** frontB(struct B* _col[])
{ int n = length((void**) _col);
  return subrangeB(_col, 1, n-1); }

struct A** tailA(struct A* _col[])
{ int n = length((void**) _col);
  return subrangeA(_col, 2, n); }

struct B** tailB(struct B* _col[])
{ int n = length((void**) _col);
  return subrangeB(_col, 2, n); }

void mapatob1_A(struct A* self)
{ struct B* b = createB(); 
  setB_y(b, getA_x(self)); 
  setB_z(b, 10); 
}

double realfact(double xx)
{ double result = 0; 
  result = 0; 
  if (xx <= 1)
  { result = 1;  }
  else 
  { if (xx > 1)
  { result = xx * realfact(xx - 1);  }  } 
  return result; 
}

void killA(struct A* a_x)
{ a_instances = removeA(a_instances, a_x); 
  free(a_x); 
}

void killB(struct B* b_x)
{ b_instances = removeB(b_instances, b_x); 
  free(b_x); 
}

void mapAtoB(void)
{ int ind_boundedloopstatement_132 = 0;
  int size_boundedloopstatement_132 = length((void**) a_instances);
  for ( ; ind_boundedloopstatement_132 < size_boundedloopstatement_132; ind_boundedloopstatement_132++)
  { struct A* loopvar_0 = (a_instances)[ind_boundedloopstatement_132];
    mapatob1_A(loopvar_0);   } 
}

void rfact(double xx)
{ displaydouble(realfact(xx)); 
}


